#!/bin/csh

    setenv LHEASOFT /iraf/irafext/lheasoft/sparc-sun-solaris2.8
    setenv LD_LIBRARY_PATH /opt/SUNWspro/lib
    source /iraf/irafext/lheasoft/sparc-sun-solaris2.8/lhea-init.csh

    set bad = 0

    ../bin/apec @@simple_apec.par > simple.out

    fdiff Simple.xspec true/Simple.xspec > fdiff.xspec
    fdiff Simple_coco.fits true/Simple_coco.fits > fdiff.coco
    fdiff Simple_comp.fits true/Simple_comp.fits > fdiff.comp
    fdiff Simple_cont.fits true/Simple_cont.fits > fdiff.cont
    fdiff Simple_line.fits true/Simple_line.fits > fdiff.line
    
    if (`fgrep -s "0 differences were found" fdiff.xspec`) then 
	echo "Simple.xspec does not match original"
	set bad = 1
    endif

    if (`fgrep -s "0 differences were found" fdiff.coco`) then 
	echo "Simple_coco.fits does not match original"
	set bad = 2
    endif

    if (`fgrep -s "0 differences were found" fdiff.comp`) then 
	echo "Simple_comp.fits does not match original"
	set bad = 3
    endif

    if (`fgrep -s "0 differences were found" fdiff.cont`) then 
	echo "Simple_cont.fits does not match original"
 	set bad = 4
    endif

    if (`fgrep -s "0 differences were found" fdiff.line`) then 
	echo "Simple_line.fits does not match original"
	set bad = 5
    endif

    if (`diff -s simple.out true/simple.out`) then 
	echo "simple.out does not match original"
	set bad = 6
    endif

    if ($bad == 0) then 
        echo "simple.inp tests OK"
	rm simple.out
	rm fdiff.xspec
	rm fdiff.coco
	rm fdiff.comp
	rm fdiff.cont
	rm fdiff.line
	rm Simple.xspec
	rm Simple_coco.fits
	rm Simple_comp.fits
	rm Simple_cont.fits
	rm Simple_line.fits
    endif
    if ($bad != 0) then
	echo "simple.inp tests FAILED."
	echo "Bombing out now."
	exit
    endif
    
    ../bin/apec @@apec_xspec_apec.par > apec_xspec.out

    fdiff APEC_XSPEC.xspec true/APEC_XSPEC.xspec > fdiff.xspec
    fdiff APEC_XSPEC_coco.fits true/APEC_XSPEC_coco.fits > fdiff.coco
    fdiff APEC_XSPEC_comp.fits true/APEC_XSPEC_comp.fits > fdiff.comp
    fdiff APEC_XSPEC_cont.fits true/APEC_XSPEC_cont.fits > fdiff.cont
    fdiff APEC_XSPEC_line.fits true/APEC_XSPEC_line.fits > fdiff.line
    
    if (`fgrep -s "0 differences were found" fdiff.xspec`) then 
	echo "APEC_XSPEC.xspec does not match original"
	set bad = 1
    endif

    if (`fgrep -s "0 differences were found" fdiff.coco`) then 
	echo "APEC_XSPEC_coco.fits does not match original"
	set bad = 2
    endif

    if (`fgrep -s "0 differences were found" fdiff.comp`) then 
	echo "APEC_XSPEC_comp.fits does not match original"
	set bad = 3
    endif

    if (`fgrep -s "0 differences were found" fdiff.cont`) then 
	echo "APEC_XSPEC_cont.fits does not match original"
 	set bad = 4
    endif

    if (`fgrep -s "0 differences were found" fdiff.line`) then 
	echo "APEC_XSPEC_line.fits does not match original"
	set bad = 5
    endif

    if (`diff -s apec_xspec.out true/apec_xspec.out`) then 
	echo "apec_xspec.out does not match original"
	set bad = 6
    endif

    if ($bad == 0) then 
        echo "apec_xspec.inp tests OK"
	rm apec_xspec.out
	rm fdiff.xspec
	rm fdiff.coco
	rm fdiff.comp
	rm fdiff.cont
	rm fdiff.line
	rm APEC_XSPEC.xspec
	rm APEC_XSPEC_coco.fits
	rm APEC_XSPEC_comp.fits
	rm APEC_XSPEC_cont.fits
	rm APEC_XSPEC_line.fits
    endif
    if ($bad != 0) then
	echo "apec_xspec.inp tests FAILED."
	echo "Bombing out now."
	exit
    endif
