#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "messages.h"

void message(const char *routine, const char *fmt, ...) {
  
  va_list ap;

  va_start(ap, fmt);  /* Point ap to first message. */
  
  /*
  printf("%s: ",routine); 
  vprintf(fmt,ap); 
  va_end(ap);
  printf("\n"); 
  fflush(stdout); 
  */

}


void errmess(const char *routine, const char *fmt, ...) {

  va_list ap;

  va_start(ap, fmt);
  printf("Error reported in: %s\n",routine);
  vprintf(fmt,ap);
  printf("\n Bombing out. \n");
  fflush(stdout);
  abort();
}

void quitmess(const char *routine, const char *fmt, ...) {

  va_list ap;

  va_start(ap, fmt);
  printf("Error reported in: %s\n",routine);
  vprintf(fmt,ap);
  printf("\n Exiting. \n");
  fflush(stdout);
  exit(1);
}


void memmess(const char *routine) {

  printf("Memory allocation error in: %s\n",routine);
  printf("\n Bombing out. \n");
  fflush(stdout);
  abort();
}

void fitsmess(const char *routine, int status, const char *fmt, ...) {
  
  va_list ap;

  va_start(ap, fmt);  /* Point ap to first message. */
  /*
  printf("FITS error number #%d\n", status);
  printf("%s: ",routine);
  vprintf(fmt,ap);
  va_end(ap);
  printf("\n");
  fflush(stdout);
  */
}


char * malloc_or_die(size_t size, char *routine) {

  char *ptr;

  ptr = (char *) malloc(size);
  if (ptr == NULL) {
    memmess(routine);
  }
  return ptr;
}
