#include <stdlib.h>
#include <stdio.h>
#include <string.h>

char *roman_element(int Z, int J) {

  /* Returns the astronomical ion name for the Z, J ion.  */
  
  char *Element[30] = {"H","He","Li","Be","B","C","N","O","F","Ne",
		       "Na","Mg","Al","Si","P","S","Cl","Ar","K","Ca",
		       "Sc","Ti","V","Cr","Mn","Fe","Co","Ni","Cu","Zn"};
  char *Numeral[30] = {"I","II","III","IV","V","VI","VII","VIII","IX","X",
		       "XI","XII","XIII","XIV","XV","XVI","XVII","XVIII",
		       "XIX","XX","XXI","XXII","XXIII","XXIV","XXV","XXVI",
		       "XXVII","XXVIII","XXIX","XXX"};
  char name[20], *shortname;
  int length;

  sprintf(name,"%s %s",Element[Z-1],Numeral[J]);
  length = strlen(name);

  shortname = (char *) malloc((length+1)*sizeof(char));
  if (shortname == NULL) {
    fprintf(stderr,"roman_element: error allocating memory.\n");
  } else {
    strcpy(shortname, name);
  }
  return shortname;
}

char *element_name(int Z) {

  /* Returns the astronomical ion name for the Z, J ion.  */
  
  char *Element[30] = {"H","He","Li","Be","B","C","N","O","F","Ne",
		       "Na","Mg","Al","Si","P","S","Cl","Ar","K","Ca",
		       "Sc","Ti","V","Cr","Mn","Fe","Co","Ni","Cu","Zn"};
  char *name;
  
  name = (char *) malloc(3*sizeof(char));
  if (name == NULL) {
    fprintf(stderr,"element_name: error allocating memory.\n");
  } else {
    strncpy(name, Element[Z-1], 3);
  }
  return name;
}

int element_number(char *atom) {

  /* Returns the Z value for a given atom name.  */
  
  char *Element[30] = {"H","He","Li","Be","B","C","N","O","F","Ne",
		       "Na","Mg","Al","Si","P","S","Cl","Ar","K","Ca",
		       "Sc","Ti","V","Cr","Mn","Fe","Co","Ni","Cu","Zn"};
  int iZ, Z, length;
  
  Z = -1;
  for (iZ=0;iZ<30;iZ++) {
    length = strlen(atom);
    if (strlen(Element[iZ]) > length) length = strlen(Element[iZ]);
    if (strncmp(atom, Element[iZ], length) == 0) {
      Z = iZ + 1;
    }
  }

  return Z;
}

int roman_number(char *roman) {

  /* Returns the arabic value for a roman number */
  
  char *Numeral[30] = {"I","II","III","IV","V","VI","VII","VIII","IX","X",
		       "XI","XII","XIII","XIV","XV","XVI","XVII","XVIII",
		       "XIX","XX","XXI","XXII","XXIII","XXIV","XXV","XXVI",
		       "XXVII","XXVIII","XXIX","XXX"};
  int iJ, J;

  J = -1;
  for (iJ=0;iJ<30;iJ++) {
    if (strncmp(roman, Numeral[iJ], strlen(Numeral[iJ])) == 0) J = iJ + 1;
  }

  return J;
}
