;
;  Set the following string to be the directory in which the APEC 
;  code is found
;
apec_dir = getenv('ATOMDB')
if (strcmp('',apec_dir) eq 1) then print,'System variable ATOMDB not set.'
if (strcmp('',apec_dir) eq 1) then print,'Set up CIAO to set it properly.'
if (strcmp('',apec_dir) eq 1) then print,'Or, set ATOMDB to point to the atomdb directory with the apec_linelist.fits file.'
if (strcmp('',apec_dir) eq 1) then stop
;
;
;
strings = '01234567890123456789012345678901234567890123456789'
tmp1 = {IonBal_S, Temperature: 1.0, density:1.0, Z:intarr(30), $
        indx:intarr(30), X:fltarr(500), filename:strings}

tmp2 = {Emission_S, T:1.0, N:1.0, L_Tot:1.0, L_Line:1.0, $
        L_Brems:1.0, L_RRC:1.0, L_TwoPh:1.0}

tmp3 = {Coco_S, Temperature:1.0, Density:1.0, Z: 1, rmJ: 1, N_cont: 1, $
        E_Cont:fltarr(250),  Continuum:fltarr(250), Cont_Err:fltarr(250), $
        N_pseudo:1, E_Pseudo:fltarr(3500), Pseudo:fltarr(3500), $
        Pseudo_Err:fltarr(3500)}

cd, current=cdir
atomdb_idl_dir = getenv('ATOMDB_IDL')
if (strcmp('',atomdb_idl_dir) eq 1) then atomdb_idl_dir = cdir
if (strpos(!path,atomdb_idl_dir) eq -1) then $
   !path=!path+':'+atomdb_idl_dir+':'+atomdb_idl_dir+'/astro'

delvar,tmp1,tmp2,tmp3,strings,atomdb_idl_dir,cdir

.run make_range
.run read_array

.run interp_header
.run match_header
.run read_linelist
.run read_continuum
.run read_coco

.run roman_element

.run expand_E_grid
.run calc_spectrum

.run calc_ion_bal
.run extract_line
.run select_line
.run extract_strong

delvar,apec_dir
