FUNCTION interp_header, header, keyword, INT_RESULT=integ, SILENT=silent,$
                        STR_RESULT=str_result
;
;  First, strip out all HIERARCH keywords
;
header_keywords = strmid(header,0,strlen(keyword)+1)
gp = where(strpos(header_keywords,'HIERARCH') ne -1,count)
if (count ne 0) then begin
    for i=0,count-1 do begin
        header_keywords(gp(i)) = strmid(header(gp(i)),9,strlen(keyword)+1)
    endfor
endif

findstr = where(strpos(header_keywords,keyword) ne -1,count)
if (count gt 1) then begin
    if (n_elements(silent) eq 0) then $
      print,'More than one', keyword, ' in the extension.'
    if (n_elements(integ) eq 0) then begin
        value = -1.0
    endif else begin
        value = -1
    endelse
endif

if (count eq 0) then begin
    if (n_elements(silent) eq 0) then print,'No ',keyword,' in the extension'
    if (n_elements(integ) eq 0) then begin
        value = -1.0
    endif else begin
        value = -1
    endelse
endif

if (count eq 1) then begin
    keyword_str = header(findstr)
    pos_equal = strpos(keyword_str,'=')
    if (n_elements(str_result) eq 0) then begin
        if (n_elements(integ) eq 0) then begin
            if (pos_equal(0) ne -1) then begin
                value = double(strmid(keyword_str,pos_equal(0)+1,100))
                value = value(0)
            endif else begin
                value = double(strmid(keyword_str,10,100))
                value = value(0)
            endelse
        endif else begin
            if (pos_equal(0) ne -1) then begin
                value = long(strmid(keyword_str,pos_equal(0)+1,100))
                value = value(0)
                if (fix(value) eq value) then value = fix(value)
            endif else begin
                value = long(strmid(keyword_str,10,100))
                value = value(0)
                if (fix(value) eq value) then value = fix(value)
            endelse
        endelse
    endif else begin
        value = strmid(keyword_str,pos_equal(0)+1,100)
    endelse
endif

return,value

end

