FUNCTION calc_rate, Z, rmJ, ll, lu, T, SILENT=silent, FILE=file

KB = 8.617e-8
E_lu = calc_energy(Z,rmJ,lu)
E_ll = calc_energy(Z,rmJ,ll)
if ((E_lu lt 0.0)or(E_ll lt 0.0)) then begin
    if (n_elements(silent) eq 0) then print,'No appropriate energy data found'
    return,0*T
endif
dE = (E_lu - E_ll)/1.e3
degl = calc_statwt(Z,rmJ,ll)
degu = calc_statwt(Z,rmJ,lu)
chi = dE/(KB*T)
result = 8.63e-6*calc_upsilon(Z,rmJ,ll,lu,T,SILENT=silent,FILE=file)*$
  exp(-chi)/(sqrt(T)*degl)

return, result
end

FUNCTION calc_derate, Z, rmJ, ll, lu, T, SILENT=silent, FILE=file

KB = 8.617e-8
E_lu = calc_energy(Z,rmJ,lu)
E_ll = calc_energy(Z,rmJ,ll)
if ((E_lu lt 0.0)or(E_ll lt 0.0)) then begin
    if (n_elements(silent) eq 0) then print,'No appropriate energy data found'
    return,0*T
endif
dE = (E_lu - E_ll)/1.e3
degl = calc_statwt(Z,rmJ,ll)
degu = calc_statwt(Z,rmJ,lu)
chi = dE/(KB*T)
result = 8.63e-6*calc_upsilon(Z,rmJ,ll,lu,T,SILENT=silent,FILE=file)/$
  (sqrt(T)*degu)

return, result
end
