FUNCTION get_filename, Z, rmJ, filetype, SILENT=silent

common filemap_com, filemap

if (n_elements(filemap) eq 0) then begin
    if (n_elements(silent) eq 0) then begin
        print,'No filemap loaded--use read_filemap,filemap_file'
    endif
    return,' '
endif

gp = where((filemap.Z eq Z)and(filemap.filetype eq filetype),count)
if (count eq 0) then begin
    if (n_elements(silent) eq 0) then begin
        print,strcompress('No file with Z='+string(Z)+' and type='+$
                          string(filetype)+' in filemap!')
    endif
    return,''
endif
if (count eq 1) then begin
    if (filemap(gp).rmJ eq rmJ) then return,filemap(gp).filename
    if (filemap(gp).rmJ eq -1) then  return,filemap(gp).filename
    if ((filemap(gp).rmJ ne -1)and(filemap(gp).rmJ ne rmJ)) then begin
        if (n_elements(silent) eq 0) then begin
            print,strcompress('No file with Z='+string(Z)+' and type='+$
                              string(filetype)+' and rmJ='+string(rmJ)+$
                              ' or -1 in filemap!')
        endif
        return,''
    endif
endif
if (count gt 1) then begin
    gp_filemap = filemap(gp)
    gp2 = where(gp_filemap.rmJ eq rmJ,count1)
    gp3 = where(gp_filemap.rmJ eq  -1,count2)
    if (count1 gt 1) then begin
        print,'Weird--more than one perfect match.  Using first.'
        count1 = 1
        gp2 = gp2(0)
    endif
    if (count2 gt 1) then begin
        print,'Weird--more than one default match.  Using first'
        stop
    endif
    if (count1 eq 1) then begin ; found a perfect match!
        return,gp_filemap(gp2).filename
    endif
    if ((count1 eq 0)and(count2 eq 1)) then begin ; only a -1 match
        return,gp_filemap(gp3).filename
    endif
    if ((count1 eq 0)and(count2 eq 0)) then begin  ; no matches :-(
        return,''
    endif
endif

print,'Weird--should not have been able to get here.'
stop

end
