PRO read_coco, filename, coco, T_vec, N_vec, lambda_vec
;
;  Reads the continuum data from a fits file
;
done = 0
ext = 2

while (not(done)) do begin
    data = mrdfits(filename,ext,header)
    if (n_tags(data) ne 0) then begin
        lambda_val = interp_header(header, 'TOT_COCO')
        T_val = interp_header(header,'TEMPERAT')
        N_val = interp_header(header,'DENSITY')
        if (ext eq 1) then begin
            T_vec = T_val
            N_vec = N_val
            lambda_vec = lambda_val
            coco = replicate({Coco_S},1)
            coco.N_Cont = data.N_Cont
            coco.E_Cont = data.E_Cont
            coco.Continuum = data.Continuum
            coco.Cont_Err = data.Cont_Err
            coco.N_Pseudo = data.N_Pseudo
            coco.E_Pseudo = data.E_Pseudo
            coco.Pseudo = data.Pseudo
            coco.Pseudo_Err = data.Pseudo_Err
        endif else begin
            T_vec = [T_vec,T_val]
            N_vec = [N_vec,N_val]
            lambda_vec = [lambda_vec,lambda_val]
            coco_tmp = replicate({Coco_S},1)
            coco_tmp.N_Cont = data.N_Cont
            coco_tmp.E_Cont = data.E_Cont
            coco_tmp.Continuum = data.Continuum
            coco_tmp.Cont_Err = data.Cont_Err
            coco_tmp.N_Pseudo = data.N_Pseudo
            coco_tmp.E_Pseudo = data.E_Pseudo
            coco_tmp.Pseudo = data.Pseudo
            coco_tmp.Pseudo_Err = data.Pseudo_Err
            coco = [[coco],[coco_tmp]]
        endelse
        ext = ext + 1
    endif else begin
        done = 1
    endelse
endwhile

return
end
