PRO read_drline, Z, rmJ, data, header, N_ext=N_ext, FOUND=found,$
                 SILENT=silent, FILE=file, FORCE=force

common DRline_com, Z_DRline, rmJ_DRline, start_DRline, end_DRline, $
  data_DRline, header_DRline
;
;  Special file to load?
;
if ((n_elements(file) ne 0) or (n_elements(force) ne 0)) then begin
    if (n_elements(force) ne 0) then filename = get_filename(Z, rmJ, 3)
    if (n_elements(file) ne 0) then filename = file
    force = 1 
endif else begin
;
; First, check to see if this data has already been loaded
;
    count = 0
    if (n_elements(Z_DRline) ne 0) then $
      gp = where((Z eq Z_DRline)and(rmJ eq rmJ_DRline),count)
    if (count gt 1) then begin
        print,'Strange--multiple Z, rmJ matches!
        stop
    endif
; So load it and be done!
    if (count eq 1) then begin
        p1 = (start_DRline(gp))(0)
        p2 = (end_DRline(gp))(0)
        data = reform(data_DRline(p1:p2,gp))
        header = reform(header_DRline(*,gp))
        Found = 1
;    if (n_elements(silent) eq 0) then print,'Data loaded from memory'
        return
    endif else begin
        filename = get_filename(Z, rmJ, 6)
    endelse
endelse

Found = -1
Ext = match_header(filename, Z, rmJ, 'DR_LINES', N_ext=N_ext)
if (Ext eq -1) then begin
    if (n_elements(silent) eq 0) then $
      print,'No matching extension for Z, rmJ = ',$
      Z,rmJ,' found in ',filename,'.'
    return
endif

version = check_version(filename)

fxbopen, unit, filename, Ext, header
Nrow = fxpar(header, 'NAXIS2')
if (Nrow eq 0) then begin
    print,'No data in extension.'
    return
endif

fxbread, unit, Lower_Lev, 'Lower_Lev'
fxbread, unit, Upper_Lev, 'Upper_Lev'
fxbread, unit, Wavelen,   'Wavelen'
fxbread, unit, Wave_Obs,  'Wave_Obs'
fxbread, unit, Wave_Err,  'Wave_Err'
fxbread, unit, DR_Type,   'DR_Type'
fxbread, unit, E_Excite,  'E_Excite'
fxbread, unit, Eexc_Err,  'Eexc_Err'
fxbread, unit, SatelInt,  'SatelInt'
fxbread, unit, SatIntErr, 'SatIntErr'
fxbread, unit, Params,    'Params'
if (version eq 1.0) then fxbread, unit, Reference, 'Reference'
if (version eq 1.1) then begin
    fxbread, unit, DRRate_Ref, 'DRRate_Ref'
    fxbread, unit, Wave_Ref, 'Wave_Ref'
    fxbread, unit, Wv_Obs_Ref, 'Wv_Obs_Ref'
endif
if ((version ne 1.0) and (version ne 1.1)) then begin
    print,'Version ',version,' not recognized.'
    return
endif

if (version eq 1.0) then data = replicate({DRLine_S10},Nrow)
if (version eq 1.1) then data = replicate({DRLine_S11},Nrow)

data.Lower_Lev = Lower_Lev
data.Upper_Lev = Upper_Lev
data.Wavelen   = Wavelen
data.Wave_Obs  = Wave_Obs
data.Wave_Err  = Wave_Err
data.DR_Type   = DR_Type
data.E_Excite  = E_Excite
data.Eexc_Err  = Eexc_Err
data.SatelInt  = SatelInt
data.SatIntErr = SatIntErr
data.Params    = Params
if (version eq 1.0) then data.Reference = Reference
if (version eq 1.1) then begin
    data.drrate_ref = drrate_ref
    data.wave_ref = wave_ref
    data.wv_obs_ref = wv_obs_ref
endif

fxbclose, unit

Found = 1

return
end
