PRO read_elev, Z, rmJ, data, header, N_ext=N_ext, FOUND=found,$
               SILENT=silent, FILE=file, FORCE=force

common Elev_com, Z_Elev, rmJ_Elev, start_Elev, end_Elev, data_Elev, header_Elev
;
; First, check to see if this data has already been loaded
;
;
;  Special file to load?
;
if ((n_elements(file) ne 0) or (n_elements(force) ne 0)) then begin
    if (n_elements(force) ne 0) then filename = get_filename(Z, rmJ, 3)
    if (n_elements(file) ne 0) then filename = file
    force = 1
endif else begin
    count = 0
    if (n_elements(Z_Elev) ne 0) then $
      gp = where((Z eq Z_Elev)and(rmJ eq rmJ_Elev),count)
    if (count gt 1) then begin
        print,'Strange--multiple Z, rmJ matches!
        stop
    endif
; So load it and be done!
    if (count eq 1) then begin
        p1 = (start_Elev(gp))(0)
        p2 = (end_Elev(gp))(0)
        data = reform(data_Elev(p1:p2,gp))
        header = reform(header_Elev(*,gp))
        Found = 1
;    if (n_elements(silent) eq 0) then print,'Data loaded from memory'
        return
    endif else begin
        filename = get_filename(Z,rmJ,2)
    endelse
endelse

found = -1
result = findfile(filename,count=count)
if (count eq 0) then begin
    print,'No such file: ',filename
    data = -1
    return
endif
if (count gt 1) then begin
    print,'More than one file matches ',filename,': ',result
    data = -1
    return
endif

Ext = match_header(filename, Z, rmJ, 'E_LEVEL', N_ext=N_ext)
if (Ext eq -1) then begin
    if (n_elements(silent) eq 0) then $
      print,'No matching extension for Z, rmJ = ',Z,rmJ,$
      ' found in ',filename,'.'
    data = -1
    return
endif

version = check_version(filename)

fxbopen, unit, filename, Ext, header
Nrow = fxpar(header, 'NAXIS2')
if (Nrow eq 0) then begin
    print,'No data in extension.'
    return
endif

fxbread, unit, elec_config,'Elec_Config'
fxbread, unit, energy,     'Energy'
fxbread, unit, E_Error,    'E_Error'
fxbread, unit, N_quan,     'N_quan'
fxbread, unit, L_quan,     'L_quan'
fxbread, unit, S_quan,     'S_quan'
fxbread, unit, Lev_Deg,    'Lev_Deg'
fxbread, unit, Phot_Type,  'Phot_Type'
fxbread, unit, Phot_par,   'Phot_Par'
if (version eq 1.0) then begin
    fxbread, unit, Reference,  'Reference'
endif 
if (version eq 1.1) then begin
    fxbread, unit, Energy_Ref,'Energy_Ref'
    fxbread, unit, Phot_Ref,  'Phot_Ref'
endif
if ((version ne 1.0) and (version ne 1.1)) then begin
    print,'Version ',version,' not recognized'
    return
endif

if (version eq 1.0) then data = replicate({ELev_S10},Nrow)
if (version eq 1.1) then data = replicate({ELev_S11},Nrow)

data.elec_config = elec_config
data.energy = energy
data.E_Error = E_Error
data.N_quan = N_quan
data.L_quan = L_quan
data.S_quan = S_quan
data.Lev_Deg = Lev_Deg
data.Phot_Type = Phot_Type
data.Phot_par = Phot_par
if (version eq 1.0) then data.Reference = reference
if (version eq 1.1) then begin
    data.energy_ref = energy_ref
    data.phot_ref = phot_ref
endif

fxbclose, unit

found = 1

if (n_elements(force) eq 0) then begin
    if (found eq 1) then begin  ; Add data to common blocks
        if (n_elements(Z_Elev) eq 0) then begin
            Z_Elev = Z
            rmJ_Elev = rmJ
            data_Elev = data
            header_Elev = header
            start_Elev = 0
            end_Elev = n_elements(data)-1
        endif else begin
            Z_Elev = [[Z_Elev],[Z]]
            rmJ_Elev = [[rmJ_Elev],[rmJ]]
            start_pos = max(end_Elev) + 1
            end_pos = start_pos + n_elements(data)-1
            start_Elev = [[start_Elev],[start_pos]]
            end_Elev = [[end_Elev],[end_pos]]
            data_Elev = [data_Elev,data]
            header_Elev = [header_Elev,header]
        endelse
    endif
endif

return
end
