FUNCTION calc_sgc_gamma_p, data, Z, T

kT = 8.617d-8*T
y = data.coeff_OM(0) / kT

a1 = data.coeff_OM(1)+1
a1y = a1*y
r  = fix(data.coeff_OM(6))
;E1y = ExpInt(1,1.d0*y,/double)    
;expyTE1y = ExpTExpInt(1,y)    
expyTE1y = ExpInt(1,1.d0*y,/double)*exp(y)
;Ery = ExpInt(r,1.d0*a1y,/double)  
;expyTEry = ExpTExpInt(r,a1y)  
expyTEry = ExpInt(r,1.d0*a1y,/double)*exp(a1y)
;Er1y= ExpInt(r+1,1.d0*a1y,/double)
;expyTEr1y= expTExpInt(r+1,a1y)
expyTEr1y= ExpInt(r+1,1.d0*a1y,/double)*exp(a1y)
;
;  Now, check for any bad points
;
bp1 = where(finite(expyTE1y)  eq 0,c1)
bp2 = where(finite(expyTEry)  eq 0,c2)
bp3 = where(finite(expyTEr1y) eq 0,c3)

if (c1 gt 0) then expyTE1y(bp1)  = ExpTExpInt(1,y(bp1))
if (c2 gt 0) then expyTEry(bp2)  = ExpTExpInt(r,a1y(bp2))
if (c3 gt 0) then expyTEr1y(bp3) = ExpTExpInt(r+1,a1y(bp3))

;Z2gamma = data.Coeff_OM(3) + 1.333*data.Coeff_OM(2)*E1y*exp(y) + y*exp(a1y)* $
;  (data.coeff_OM(4)*Ery/(a1^(r-1)) + data.coeff_OM(5)*Er1y/(a1^r))
Z2gamma = data.Coeff_OM(3) + 1.333*data.Coeff_OM(2)*expyTE1y + $
  y*(data.coeff_OM(4)*expyTEry/(a1^(r-1)) + data.coeff_OM(5)*expyTEr1y/(a1^r))

Zeff = Z - data.Coeff_OM(7)
gamma = Z2gamma / (Zeff*Zeff)

bp = where(finite(gamma) eq 0,count)
if (count ne 0) then stop

return, gamma
end


FUNCTION calc_sgc_gamma_s,data, Z, T

kT = 8.617d-8*T
y = data.coeff_OM(0) / kT
;
;  Similar to pdat, but r = 1 always here
;
a1 = data.coeff_OM(4)+1
a1y = a1*y
;E1y = ExpInt(1,1.d0*y,/double)     
;expyTE1y = expTExpInt(1,y)     
expyTE1y = ExpInt(1,1.d0*y,/double)*exp(y)
;Ery = ExpInt(1,1.d0*a1y,/double)   
;expyTEry = expTExpInt(1,a1y)   
expyTEry = ExpInt(1,1.d0*a1y,/double)*exp(a1y)
;Er1y= ExpInt(2,1.d0*a1y,/double)   
;expyTEr1y= expTExpInt(2,a1y)   
expyTEr1y= ExpInt(2,1.d0*a1y,/double)*exp(a1y)
;
;  Now, check for any bad points
;
bp1 = where(finite(expyTE1y)  eq 0,c1)
bp2 = where(finite(expyTEry)  eq 0,c2)
bp3 = where(finite(expyTEr1y) eq 0,c3)
if (c1 gt 0) then expyTE1y(bp1)  = ExpTExpInt(1,y(bp1))
if (c2 gt 0) then expyTEry(bp2)  = ExpTExpInt(1,a1y(bp2))
if (c3 gt 0) then expyTEr1y(bp3) = ExpTExpInt(2,a1y(bp3))

;Z2gamma=data.coeff_OM(5) + 1.333*data.coeff_OM(3)*E1y*exp(y) + $
;  y*exp(a1y)*(data.coeff_OM(6)*Ery+data.coeff_OM(7)*Er1y/a1)
Z2gamma=data.coeff_OM(5) + 1.333*data.coeff_OM(3)*expyTE1y + $
  y*(data.coeff_OM(6)*expyTEry+data.coeff_OM(7)*expyTEr1y/a1)
;
;  The _e one has c0 = Z2S = 0.
;
a1 = data.coeff_OM(8)+1
a1y = a1*y
r  = fix(data.coeff_OM(11))
;Ery = ExpInt(r,1.d0*a1y,/double)   
;expyTEry = expTExpInt(r,1.d0*a1y)   
expyTEry = ExpInt(r,1.d0*a1y,/double)*exp(a1y)
;Er1y= ExpInt(r+1,1.d0*a1y,/double) 
;expyTEr1y= expTExpInt(r+1,1.d0*a1y) 
expyTEr1y= ExpInt(r+1,1.d0*a1y,/double)*exp(a1y)
;
;  Now, check for any bad points
;
bp2 = where(expyTEry eq 0 or finite(expyTEry)  eq 0,c2)
bp3 = where(expyTEr1y eq 0 or finite(expyTEr1y) eq 0,c3)
if (c2 gt 0) then expyTEry(bp2)  = ExpTExpInt(r,a1y(bp2))
if (c3 gt 0) then expyTEr1y(bp3) = ExpTExpInt(r+1,a1y(bp3))

;Z2gamma_e = y*exp(a1y)*(data.coeff_OM(9)*Ery/(a1^(r-1)) + $
;                        data.coeff_OM(10)*Er1y/(a1^r))
Z2gamma_e = y*(data.coeff_OM(9) *expyTEry/(a1^(r-1)) + $
               data.coeff_OM(10)*expyTEr1y/(a1^r))
;
;  Now renormalize
;
Zeff = Z - data.coeff_OM(12)
Zeffe= Z - data.coeff_OM(13)

gamma = data.coeff_OM(1)*Z2gamma/(Zeff*Zeff) + $
  data.coeff_OM(2)*Z2gamma_e/(Zeffe*Zeffe)

bp = where(finite(gamma) eq 0,count)
if (count ne 0) then stop

return, gamma
end

FUNCTION calc_sgc_gamma_h, data, Z, T

kT = 8.617d-8*T
y = data.coeff_OM(0) / kT
;
;  Similar to pdat, but r = 1 always here
;
a1 = data.coeff_OM(2)+1
a1y = a1*y
;E1y = ExpInt(1,1.d0*y,/double)
;Ery = ExpInt(1,1.d0*a1y,/double) 
;Er1y= ExpInt(2,1.d0*a1y,/double) 
expyTE1y = exp(y)*ExpInt(1,1.d0*y,/double)
expyTEry = exp(a1y)*ExpInt(1,1.d0*a1y,/double) 
expyTEr1y= exp(a1y)*ExpInt(2,1.d0*a1y,/double) 
;
;  Now, check for any bad points
;
bp1 = where(finite(expyTE1y)  eq 0,c1)
bp2 = where(finite(expyTEry)  eq 0,c2)
bp3 = where(finite(expyTEr1y) eq 0,c3)
if (c1 gt 0) then expyTE1y(bp1)  = ExpTExpInt(1,y(bp1))
if (c2 gt 0) then expyTEry(bp2)  = ExpTExpInt(1,a1y(bp2))
if (c3 gt 0) then expyTEr1y(bp3) = ExpTExpInt(2,a1y(bp3))

;Z2gamma=data.coeff_OM(3) + 1.333*data.coeff_OM(1)*E1y*exp(y) + $
;  y*exp(a1y)*(data.coeff_OM(4)*Ery+data.coeff_OM(5)*Er1y/a1)
Z2gamma=data.coeff_OM(3) + 1.333*data.coeff_OM(1)*expyTE1y + $
  y*(data.coeff_OM(4)*expyTEry+data.coeff_OM(5)*expyTEr1y/a1)
;
;  Now renormalize
;
Zeff = Z 

gamma = 2*data.coeff_OM(6)*Z2gamma/(Zeff*Zeff)
; extra 2x due to stat weight; see 1978, 1981, 1983
; Sampson etal papers

bp = where(finite(gamma) eq 0,count)
if (count ne 0) then stop

return, gamma
end

FUNCTION calc_sgc, data, Z, T

if (data.Coeff_Type eq 31) then begin ; SGC S-type He-like transition
    result = calc_sgc_gamma_s(data, Z, T)
endif
if (data.Coeff_Type eq 32) then begin ; SGC P-type He-like transition
    result = calc_sgc_gamma_p(data, Z, T)
endif
if (data.Coeff_Type eq 33) then begin ; SGC S-type H-like transition
    result = calc_sgc_gamma_h(data, Z, T)
endif

return, result

end
