FUNCTION ionbal, Z, rmJ, T, FILE=file

common c_ionbal, ionbal_data, ionbal_file, ionbal_indx

header = '/data/rsmith/pse/aped/fitsfiles/'

if (n_elements(file) eq 0) then begin
    file = header+'RS93_ionbal.fits'
endif else begin
    file = header+file
endelse

if (n_elements(ionbal_data) eq 0) then begin
    ionbal_file = file
    ionbal_data = mrdfits(file, 1)
    ionbal_Z = ionbal_data(0).Z_element
    N_Z = n_elements(ionbal_Z)
    ionbal_indx = intarr(N_Z)
    for i=1,N_Z-1 do ionbal_indx(i) = ionbal_indx(i-1) + ionbal_Z(i-1) + 1
endif else begin
    if (ionbal_file ne file) then begin
        ionbal_file = file
        ionbal_data = mrdfits(file, 1)
        ionbal_Z = ionbal_data(0).Z_element
        N_Z = n_elements(ionbal_Z)
        ionbal_indx = intarr(N_Z)
        for i=1,N_Z-1 do ionbal_indx(i) = ionbal_indx(i-1) + ionbal_Z(i-1) + 1
    endif
endelse

gp = where(Z eq ionbal_data(0).Z_element,count)
if (count eq 0) then begin
    print,'Element ',Z,' not in file ',file
    return,0
endif
pos = ionbal_indx(gp) + rmJ - 1
Tvec = ionbal_data.Temperature
Xvec = ionbal_data.X_ionpop(pos)
gp = where((T ge min(Tvec))and(T le max(Tvec)),count)
result = 0*T
if (count eq 0) then begin
    print,'Cannot extrapolate data in file ',ionbal_file,$
      ' to temperature(s) ', T
endif else begin
    result(gp) = interpol(Xvec, Tvec, T(gp))
endelse

return, result
end
