
PRO merge_elev, Z, file1, rmJ1, file2, rmJ2, outputfile
;
;  Merging issues:
;   1) Take two files with disjunct ion values, and merge them (easy)
;   2) Take two files with some overlap in ion values, but only one
;      file has the correct set for each ion, and this is selected.
;   3) Two files with overlapping ion values, but no overlap in transitions.
;      Merge them, including the headers.  
;   4) Two files with overlapping ion values, and overlap in transitions.
;      One file type should overwrite the other (file1 beats file2) .
;
if (n_elements(Z) ne 1) then begin
    print,'Z is required, and can have only 1 value'
    return
end

nJ1 = n_elements(rmJ1)
nJ2 = n_elements(rmJ2)
rmJm= [rmJ1,rmJ2]
rmJm= rmJm(sort(rmJm))
rmJm= rmJm(uniq(rmJm))
nJ  = n_elements(rmJm)

for i=0,nJ-1 do begin
    rmJ = rmJm(i)
    gp1 = where(rmJ eq rmJ1,c1)
    gp2 = where(rmJ eq rmJ2,c2)
    N1 = -1
    N2 = -1
    if (c1 ne 0) then $
      read_elev, Z, rmJ, tmpdata1, header1, Found=N1,/silent, FILE=file1
    if (c2 ne 0) then $
      read_elev, Z, rmJ, tmpdata2, header2, Found=N2,/silent, FILE=file2
    if ((c1 ne 0) and (N1 eq -1)) then $
      print,strcompress('Cannot find '+string(rmJ)+' in '+file1)
    if ((c2 ne 0) and (N2 eq -1)) then $
      print,strcompress('Cannot find '+string(rmJ)+' in '+file2)
    
;    if ((N1 eq -1) and (N2 eq -1)) then begin
;        print,strcompress('Cannot find '+string(rmJ)+' in '+file1+$
;                          ' or '+file2)
;        print,'Hope that''s ok.'
;    endif
    if ((N1 ne -1) and( N2 ne -1)) then begin
        print,strcompress('Found '+string(rmJ)+' in '+file1+' AND '+file2)
        data = tmpdata1
        if (n_elements(tmpdata2) gt n_elements(data)) then begin
            nel1 = n_elements(tmpdata1)
            data = [tmpdata1,tmpdata2(nel1:*)]
        endif
        write_elev, outputfile, Z, rmJ, data, COMMENTS=[header1,header2]
    endif
    if ((N1 ne -1)and(N2 eq -1)) then begin
        write_elev, outputfile, Z, rmJ, tmpdata1, COMMENTS=header1
    endif
    if ((N1 eq -1)and(N2 ne -1)) then begin
        write_elev, outputfile, Z, rmJ, tmpdata2, COMMENTS=header2
    endif
endfor

return
end
