
PRO merge_eline, Z, file1, rmJ1, file2, rmJ2, outputfile
;
;  Merging issues:
;   1) Take two files with disjunct ion values, and merge them (easy)
;   2) Take two files with some overlap in ion values, but only one
;      file has the correct set for each ion, and this is selected.
;   3) Two files with overlapping ion values, but no overlap in transitions.
;      Merge them, including the headers.  
;   4) Two files with overlapping ion values, and overlap in transitions.
;      One file type should overwrite the other (file1 beats file2) .
;
if (n_elements(Z) ne 1) then begin
    print,'Z is required, and can have only 1 value'
    return
end

nJ1 = n_elements(rmJ1)
nJ2 = n_elements(rmJ2)
rmJm= [rmJ1,rmJ2]
rmJm= rmJm(sort(rmJm))
rmJm= rmJm(uniq(rmJm))
nJ  = n_elements(rmJm)

for i=0,nJ-1 do begin
    rmJ = rmJm(i)
    gp1 = where(rmJ eq rmJ1,c1)
    gp2 = where(rmJ eq rmJ2,c2)
    N1 = -1
    N2 = -1
    if (c1 ne 0) then $
      read_eline, Z, rmJ, tmpdata1, header1, Found=N1,/silent, FILE=file1
    if (c2 ne 0) then $
      read_eline, Z, rmJ, tmpdata2, header2, Found=N2,/silent, FILE=file2
    if ((c1 ne 0) and (N1 eq -1)) then $
      print,strcompress('Cannot find '+string(rmJ)+' in '+file1)
    if ((c2 ne 0) and (N2 eq -1)) then $
      print,strcompress('Cannot find '+string(rmJ)+' in '+file2)
    
;    if ((N1 eq -1) and (N2 eq -1)) then begin
;        print,strcompress('Cannot find '+string(rmJ)+' in '+file1+$
;                          ' or '+file2)
;        print,'Hope that''s ok.'
;    endif
    if ((N1 ne -1) and( N2 ne -1)) then begin
        print,strcompress('Found '+string(rmJ)+' in '+file1+' AND '+file2)
        data = [tmpdata1, tmpdata2]
        ll_arr = data.Lower_Lev
        ul_arr = data.Upper_Lev
        for j=0,n_elements(data)-1 do begin
            ll = ll_arr(j)
            ul = ul_arr(j)
            bp = where((ll eq ll_arr)and(ul eq ul_arr),count)
            if (count gt 1) then begin
                print,strcompress('Found multiple ('+$
                                  strcompress(string(count))+$
                                  ') matches for '+strcompress(string(ll))+$
                                  ' to '+strcompress(string(ul))+'.  Fixing')
                bp1 = where((ll eq tmpdata1.Lower_Lev) and $
                            (ul eq tmpdata1.Upper_Lev),c1)
                gp2 = where((ll ne tmpdata2.Lower_Lev) or $
                            (ul ne tmpdata2.Upper_Lev),c2)
                if (c2 eq 0) then begin
                    print,'NO good points?  Weird.'
                    stop
                endif
                if (c1 gt 1) then begin
                    print,'Multiple identical transitions in the primary!'
                    stop
                endif
                tmpdata2 = tmpdata2(gp2)
            endif
        endfor
        data = [tmpdata1, tmpdata2]
        write_eline, outputfile, Z, rmJ, data, COMMENTS=[header1,header2]
    endif
    if ((N1 ne -1)and(N2 eq -1)) then begin
        write_eline, outputfile, Z, rmJ, tmpdata1, COMMENTS=header1
    endif
    if ((N1 eq -1)and(N2 ne -1)) then begin
        write_eline, outputfile, Z, rmJ, tmpdata2, COMMENTS=header2
    endif
endfor

return
end
