PRO read_ecoll, Z, rmJ, data, header, N_ext=N_ext, FOUND=found,$
                SILENT=silent, FILE=file

common Ecoll_com, Z_Ecoll, rmJ_Ecoll, start_Ecoll, end_Ecoll, $
  data_Ecoll, header_Ecoll
;
;  Special file to load?
;
if (n_elements(file) ne 0) then begin
    filename = file
endif else begin
;
; Check to see if this data has already been loaded
;
    count = 0
    if (n_elements(Z_Ecoll) ne 0) then $
      gp = where((Z eq Z_Ecoll)and(rmJ eq rmJ_Ecoll),count)
    if (count gt 1) then begin
        print,'Strange--multiple Z, rmJ matches!
        stop
    endif
; So load it and be done!
    if (count eq 1) then begin
        p1 = (start_Ecoll(gp))(0)
        p2 = (end_Ecoll(gp))(0)
        data = reform(data_Ecoll(p1:p2,gp))
        header = reform(header_Ecoll(*,gp))
        Found = 1
;    if (n_elements(silent) eq 0) then print,'Data loaded from memory'
        return
    endif
    filename = get_filename(Z,rmJ,4)
endelse

Found = -1
Ext = match_header(filename, Z, rmJ, 'COLL_STR', N_ext=N_ext)
if (Ext eq -1) then begin
    if (n_elements(silent) eq 0) then $
      print,'No matching extension for Z, rmJ = ',Z,rmJ,$
      ' found in ',filename,'.'
    return
endif

fxbopen, unit, filename, Ext, header
Nrow = fxpar(header, 'NAXIS2')
if (Nrow eq 0) then begin
    print,'No data in extension.'
    return
endif

fxbread, unit, Lower_Lev,  'Lower_Lev'
fxbread, unit, Upper_Lev,  'Upper_Lev'
fxbread, unit, Coeff_Type, 'Coeff_Type'
fxbread, unit, Min_Temp,   'Min_Temp'
fxbread, unit, Max_Temp,   'Max_Temp'
fxbread, unit, Temperature,'Temperature'
fxbread, unit, Coeff_OM,   'Coeff_OM'
fxbread, unit, Reference,  'Reference'

data = replicate({EColl_S},Nrow)
data.Lower_Lev = Lower_Lev
data.Upper_Lev = Upper_Lev
data.Coeff_Type = Coeff_Type
data.Min_Temp  = Min_Temp
data.Max_Temp  = Max_Temp
data.Temperature = Temperature
data.Coeff_OM = Coeff_OM
data.Reference = Reference

fxbclose, unit

found = 1

if ((n_elements(file) eq 0) and (found eq 1)) then begin 
; Add data to common blocks
    if (n_elements(Z_Ecoll) eq 0) then begin
        Z_Ecoll = Z
        rmJ_Ecoll = rmJ
        data_Ecoll = data
        header_Ecoll = header
        start_Ecoll = 0
        end_Ecoll = n_elements(data)-1
    endif else begin
        Z_Ecoll = [[Z_Ecoll],[Z]]
        rmJ_Ecoll = [[rmJ_Ecoll],[rmJ]]
        start_pos = max(end_Ecoll) + 1
        end_pos = start_pos + n_elements(data)-1
        start_Ecoll = [[start_Ecoll],[start_pos]]
        end_Ecoll = [[end_Ecoll],[end_pos]]
        data_Ecoll = [data_Ecoll,data]
        header_Ecoll = [header_Ecoll,header]
    endelse
endif

return
end
