;
;  Set the following string to be the directory in which the APEC 
;  code is found
;
apec_dir = getenv('APEC_DIR')
if (strcmp('',apec_dir) eq 1) then print,'System variable APEC_DIR not set!'
if (strcmp('',apec_dir) eq 1) then print,'Set it to the APEC directory root.'
if (strcmp('',apec_dir) eq 1) then stop
;
;
;

strings = '01234567890123456789012345678901234567890123456789'

tmp1 = {ELev_S,elec_config:strings,energy:1.0,E_Error:1.0,$
        N_quan:1L,L_quan:1L,S_quan:1.0, Lev_Deg:1L, Phot_Type:1L,$
        Phot_Par:fltarr(20), Reference:strings}

tmp2 = {EColl_S,Lower_Lev:1L,Upper_Lev:1L,Coeff_Type:1L,Min_Temp:1.0,$
        Max_Temp:1.0,Temperature:fltarr(20),Coeff_OM:fltarr(20),$
        Reference:strings}

tmp3 = {ELine_S,Lower_Lev:1L,Upper_Lev:1L,Wavelen:1.0, Wave_Obs:1.0, $
        Wave_Err:1.0, Einstein_A:1.0, Ein_A_Err:1.0, Reference: strings}

tmp4 = {DRLine_S,Lower_Lev:1L,Upper_Lev:1L,Wavelen:1.0,Wave_Obs:1.0, $
        Wave_Err:1.0, DR_Type:1L, E_Excite:1.0, Eexc_Err:1.0, SatelInt:1.0, $
        SatIntErr:1.0, Params: fltarr(10),Reference: strings}

tmp5 = {Ioniz_gr_S, N_E_SH: 1L, Sh_Label:strings, N_q:1L, L_q:1L, Energy:1.0,$
        E_Error:1.0, CollType:1L, CollCoef:fltarr(10), PhotType:1L, $
        PhotCoef:fltarr(10), RR_Type:1L, RR_Coef:fltarr(10), DR_Type:1L,$
        DR_Coef:fltarr(20), Reference:strings}

tmp6 = {FileMap_S, filetype:1, Z:1, rmJ:1, filename:strings}

tmp7 = {IonBal_S, Temperature: 1.0, density:1.0, Z:intarr(30), $
        indx:intarr(30), X:fltarr(500), filename:strings}

tmp8 = {Emission_S, T:1.0, N:1.0, L_Tot:1.0, L_Line:1.0, $
        L_Brems:1.0, L_RRC:1.0, L_TwoPh:1.0}

tmp9 = {Coco_S, Temperature:1.0, Density:1.0, Z: 1, rmJ: 1, N_cont: 1, $
        E_Cont:fltarr(250),  Continuum:fltarr(250), Cont_Err:fltarr(250), $
        N_pseudo:1, E_Pseudo:fltarr(3500), Pseudo:fltarr(3500), $
        Pseudo_Err:fltarr(3500)}

apec_idl_dir = apec_dir+'/idl'
if (strpos(!path,apec_idl_dir) eq -1) then !path=!path+':'+apec_idl_dir

delvar,tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7,tmp8,tmp9,strings,apec_idl_dir

.run make_range
.run read_array
.run read_filemap
.run get_filename

.run interp_header
.run match_header
.run read_linelist
.run read_continuum
.run read_coco

.run read_drline
.run write_drline
.run merge_drline

.run read_ecoll
.run write_ecoll
.run merge_ecoll

.run read_eline
.run write_eline
.run merge_eline

.run read_elev
.run write_elev
.run merge_elev

.run read_ioniz_gr
.run write_ioniz_gr
.run merge_ioniz_gr

.run roman_element

.run expTexpint

.run expand_E_grid
.run calc_spectrum

.run calc_energy
.run calc_statwt
.run calc_wavelength
.run calc_einstein_A
.run calc_chianti
.run calc_kato
.run calc_sgc
.run fix_ups_interp
.run calc_upsilon
.run calc_rate
.run calc_p_upsilon
.run calc_p_rate
.run calc_ion_bal
.run extract_line
.run select_line
.run calc_levpop
.run extract_strong

.run zscale_elev
.run zscale_wgfa
.run zscale_ecoll

read_filemap, apec_dir+'/FileMaps/BestMap'

delvar,apec_dir
