%
%
%
%
%
%
% Ronnie Hoogerwerf, SAO, 07/22/2002
%
private define print_levels();
define AM_remove_line() {
   
   variable usage = "AM_remove_line(dataset_range,Z[,ion[,upper_level[,lower_level]]]);";
   variable new_remove = @RemoveLine_Type;
   variable dataset, Z, ion = NULL, ul = NULL, ll = NULL;

   switch (_NARGS) 
   { case 2 : (dataset, Z) = (); }
   { case 3 : (dataset, Z, ion) = (); }
   { case 4 : (dataset, Z, ion, ul) = (); }
   { case 5 : (dataset, Z, ion, ul, ll) = (); }
   { case 6 : (dataset, Z, ion, ul, ll) = (); }
   { message(usage); _pop_n(_NARGS); return; }

   % Error checking
   if (Integer_Type == typeof(dataset)) {
      dataset = [dataset];
   } else if (String_Type == typeof(dataset)) {
      if (dataset == "all") {
	 dataset = [0];
      } else {
	 dataset = AM_parse_dataset_range(dataset);
      }
   } else {
      message("AM_remove_line: received incorrect dataset.");
   }

   if (typeof(Z) == String_Type) {
      if (assoc_key_exists(AM->Elem_to_Z,strlow(Z))) {
	 Z = AM->Elem_to_Z[strlow(Z)];
      } else {
	 verror("Element %s is not part of the apec model",Z);
      }
   }

   if (typeof(ion) == String_Type) {
      if (assoc_key_exists(AM->Roman_to_I,strlow(ion))) {
	 ion = AM->Roman_to_I[strlow(ion)];
      } else {
	 verror("Ion %s is not part of the apec model",ion);
      }
   }

   if (andelse {ul != NULL} {typeof(ul) != Array_Type}) {
      ul = [ul];
   }

   if (andelse {ll != NULL} {typeof(ll) != Array_Type}) {
      ll = [ll];
   }

   set_struct_fields(new_remove,dataset,Z,ion,ul,ll);
   
   AM->remove = LL->append(new_remove,AM->remove);

}

define AM_reset_remove () {

   %
   % Reset the fixed lines. This command discards of all
   % elements/lines that have been fixed.
   %

   AM->remove = NULL;

}

define AM_show_remove () {

   % 
   % Displays the information of the lines that are fixed and also 
   % provides the command to discard of a certain line.
   %

   variable tmpremove = AM->remove, remove, i = 0, remove_str;

   if (tmpremove == NULL) {
      message("There are no removed lines");
      return;
   }

   message(" #  Z      ion          UL         LL        Datasets | To remove");
   message("===================================================================");
   foreach (tmpremove) {
      remove = ();

      remove_str = sprintf("AM_remove_remove(%d)",i);
      vmessage("%2d  %2s  %6s  %10s %10s %15s | %s",
	       i,
	       AM_strZ(remove.content.Z),
	       AM_strIon(remove.content.ion),
	       print_levels(remove.content.ul),
	       print_levels(remove.content.ll),
      print_datasets(remove.content.dataset),
	       remove_str);
      i++;
   }

}

private define print_levels(levels) {

   variable str = "(", l, i, n;

   if (levels == NULL) return "";
   
   n = length(levels) - 1;
   for (i = 0; i <= n; i++) {

      str = str + string(levels[i]);
      if (i == n) {
	 str = str+")";
      } else {
	 str = str+",";
      }
   }

   return str;

}

define AM_remove_remove(i) {

   %
   % Remove the ith entry from the list of fixed elements/ions.
   %

   AM->remove = LL->remove(i,AM->remove);

}
