define expand_env(FileName) {

   %
   %  Given a filename string which may (or may not) contain a 
   %  single environment variable, expand the environment variable
   %  and return the full filename.
   %

   variable expanded_FileName, envar, expanded_envar, envpos1, envpos2;
   
   if (FileName == NULL) {
      message("Call as: full_filename = expand_env(FileName)");
      return NULL;
   }
   
   envpos1 = string_match(FileName,"\\$",1);
   envpos2 = string_match(FileName,"/",envpos1);

   if (envpos1 == 0) {
      expanded_FileName = FileName;  % No environment variable to expand
   } else {
      if (envpos2 == 0) {
	 envar = FileName[[envpos1-1:]];
      } else {
	 envar = FileName[[envpos1-1:envpos1-1+envpos2-2]];
      }
      expanded_envar = getenv(envar[[1:]]);
      if (expanded_envar == NULL) {
	 vmessage("expand_env: Environment variable %s in string %s undefined",
		  envar, FileName);
	 return NULL;
      }
      %	 vmessage("envar=%s",envar);
      
      (expanded_FileName,) = str_replace(FileName, envar, expanded_envar);
   }
   return expanded_FileName;
}
