%
%
%
%
%
%
variable _apec_initialized;
variable _apec_loaded;

%
% Run the following commands only at startup of the module
%
if (__is_initialized(&_apec_initialized) == 0) {
   _apec_initialized = 1;

   %
   % first load the c-code library.
   %
   import("plasma");

   %
   % second load all SLang definitions, etc.
   %
   () = evalfile("_mymodel_tricks.sl");
   () = evalfile("_mymodel_misc.sl");
   () = evalfile("_mymodel_load_apec_model.sl");
   () = evalfile("_mymodel_models.sl");
   () = evalfile("_mymodel_em.sl");

   %
   % Some global variables
   %

}



if (__is_initialized(&_apec_loaded) == 0) {
   _apec_loaded = 1;
   
   %
   % load the default low density apec model output.
   %
   vmessage("Loading default apec model named \"apec\"");
   load_default_apecmodel();
   setup_apec_models();
   setup_em_models();
}   

% Tell SLang that the module _mymodel is available. The provide function
% works together with require. require("_mymodel"); loads all slang
% and c-code related to apec.
provide("_mymodel");
