      subroutine setup_wisc(WisFile)

      implicit none
      
      include 'jr_common.inc'
      integer MAXSTEPS, WILUN
      parameter(MAXSTEPS=1000,WILUN=13)

      character*128 WisFile
      real Bband(MAXSTEPS),Cband(MAXSTEPS),BEband(MAXSTEPS)
      real Bpband(MAXSTEPS),M1band(MAXSTEPS),M2band(MAXSTEPS)
      common/wiscbands/Bband,Cband,BEband,Bpband,M1band,M2band

      call read_band()
      open(unit=WILUN,file=WisFile,status='NEW')

      write(WILUN,*) 'Fluence B (c/s)  C (c/s)  Be (c/s) Bp (c/s)',
     $     'M1 (c/s) M2 (c/s)'

      return
      end


      subroutine close_wisc()

      implicit none
      integer WILUN
      parameter(WILUN=13)

      close(unit=WILUN)
      
      return
      end

      subroutine output_wisc(fluenc, dene, chi)

      implicit none
      integer WILUN
      parameter(WILUN=13)

      include 'jr_common.inc'
      real Bcount,Ccount,BEcount,Bpcount,M1count,M2count
      real T,dene,chi,denH,coeff, fluenc
      real EnergyBin(MAXBINS)
      real Bresp(MAXBINS),Cresp(MAXBINS)
      real BEresp(MAXBINS),Bpresp(MAXBINS)
      real M1resp(MAXBINS),M2resp(MAXBINS)
      common/response/EnergyBin,Bresp,Cresp,BEresp,Bpresp,
     $     M1resp,M2resp

      integer i
      real Bint,Cint,BEint,Bpint,M1int,M2int

      denH = (dene/(chi-1.))/1.1

      Bint = 0.
      Cint = 0.
      BEint = 0.
      Bpint = 0.
      M1int = 0.
      M2int = 0.

      do i=1,nbin
         Bint = Bint + (BIN(I)/EnergyBin(I))*Bresp(I)
         Cint = Cint + (BIN(I)/EnergyBin(I))*Cresp(I)
         BEint= BEint+ (BIN(I)/EnergyBin(I))*BEresp(I)
         Bpint= Bpint+ (BIN(I)/EnergyBin(I))*Bpresp(I)
         M1int= M1int+ (BIN(I)/EnergyBin(I))*M1resp(I)
         M2int= M2int+ (BIN(I)/EnergyBin(I))*M2resp(I)
      end do

      coeff = 1.E-23*cmpc/(4*pi*ergev)

      Bcount  = coeff*Bint*dene*denH
      Ccount  = coeff*Cint*dene*denH
      BEcount = coeff*BEint*dene*denH
      Bpcount = coeff*Bpint*dene*denH
      M1count = coeff*M1int*dene*denH
      M2count = coeff*M2int*dene*denH

      write(WILUN,1000) fluenc, Bcount, Ccount, BEcount, Bpcount,
     $     M1count, M2count

 1000 FORMAT(1pe8.2,6e9.2)

      return
      end
