#include <stdlib.h>
#include <stdio.h>
#include <math.h>

void miev0_(float *xx, float crefin[], int *MIEV_perfct, float *mimcut, 
	    int *MIEV_anyang, int *MIEV_numang, float *xmu, 
	    int *MIEV_nmom, int *MIEV_ipolzn, int *MIEV_momdim, 
	    int MIEV_prnt[], float *qext, float *qsca, float *gqsc, 
	    float *pmom, float sforw[], float sback[], float s1[], 
	    float s2[], float tforw[], float tback[], float *spike);

int main(int argc, char *argv[]) {

  float xx;
  float crefin[2];
  int perfct;
  float mimcut;
  int anyang;
  int numang; 
  float *xmu;
  int nmom;
  int ipolzn;
  int momdim;
  int prnt[2];
  float qext;
  float qsca;
  float gqsc;
  float *pmom;
  float sforw[2];
  float sback[2];
  float *s1;
  float *s2;
  float *tforw; /* Array of 4 ... */
  float *tback; /* Array of 4 ... */
  float spike;
  int i;

  xx = 2*3.1415926*1.0/(12.4e-4/1.0);
  crefin[0] = 1-(6.229e-4/(1.0*1.0));
  crefin[1] = 0.1;
  perfct = 0;
  mimcut = 0.0;
  anyang = 1;
  numang = 100; 
  xmu = (float *) malloc(numang*sizeof(float));
  for (i=0;i<numang;i++) xmu[i] = cos(i*10./((180./3.1415926)*60.*60.));
  nmom = 0;
  ipolzn = 0;
  momdim = 10;
  prnt[0] = 0;
  prnt[1] = 0;
  pmom = (float *) malloc(momdim*(nmom+1)*sizeof(float)); 
  for (i=0;i<momdim*(nmom+1);i++) pmom[i] = 0.0;
  sforw[0] = 0.0;
  sforw[1] = 0.0;
  sback[0] = 0.0;
  sback[1] = 0.0;
  s1 = (float *) malloc(2*numang*sizeof(float));
  s2 = (float *) malloc(2*numang*sizeof(float));
  for (i=0;i<2*numang;i++) s1[i] = 0.0;
  for (i=0;i<2*numang;i++) s2[i] = 0.0;
  tforw = (float *) malloc(4*sizeof(float));
  tback = (float *) malloc(4*sizeof(float));
  for (i=0;i<4;i++) tforw[i] = 0.0;
  for (i=0;i<4;i++) tback[i] = 0.0;
  
  miev0_(&xx, crefin, &perfct, &mimcut, &anyang, &numang, xmu,
	 &nmom, &ipolzn, &momdim, prnt, &qext, &qsca, &gqsc, pmom, 
	 sforw, sback, s1, s2, tforw, tback, &spike);

  printf("%10.2f %10.5f %10.5f %10.5f\n",xx, qext, qsca, gqsc);
  printf("%10.2f %10.5f %10.5f %10.5f\n",sforw[0], sforw[1], 
	 sback[0], sback[1]);
  printf("%10.2f %10.5f %10.5f %10.5f\n",s1[198], s1[199], s2[100], s2[101]);
  
}
