C  evolve.h -- header for table driven evolution routines
C
C  modified 8/3/88 by rje to include aluminum
C  Modified 8/4/94 by rje to include new Fe III + He II cx rate
c
      integer Nions,num,num1
      integer NcxH, NcxH1, NcxHe, NcxHe1

      parameter (Nions=195,num=14,num1=13)
      parameter (NcxH=7,NcxH1=8,NcxHe=7,NcxHe1=8)
C     common /conce/ X(Nions)
C
C  X(Nions) is the ionfraction vector
C
      integer index,nj,iH,iHe
      real    temp,rion,rrec,cool,cxHr,cxHer,cxHi
      real    cxHei,pcl,abundinit

      common /logT/ index(num),nj(num),abundinit(num),temp(41)
      common /table/ rion(41,Nions),rrec(41,Nions),cool(41,Nions)
      common /cx/cxHr(11,Nions),cxHer(11,Nions),cxHi(11,NcxH),
     #     iH(NcxH1),cxHei(11,NcxHe),iHe(NcxHe1)
      common /pc/ pcl(num)
C
C	index(no) = pointer to start of element 'no'
C	nj(no) = atomic number Z of element 'no'
C	abund(no) = abundance (log10, H=12.00) of element 'no'
C	temp(it) = log10 of temperatures in table
C
C	rion(it,k) = ion rate coeff at temp(it) for ion k
C	rrec(it,k) = recomb ...
C	cool(it,k) = cooling rate per ion (10**-23 cgs)
C		for ion k at temp(it)
C	cxHr = charge exchange Recombination with H
C	cxHer =   "     "        "            "   He
C	cxHi =    "     "      Ionization     "   H
C	cxHei =   "     "      Ionization     "   He
C	iH and iHe are indices (to 'k' dimension) for
C	  these last 2 tables.  End with zeroes.
c	NcxH[e] are the number of CXI rates for H [He]
c	NcxH[e]1 = NcxH[e] + 1.
C
C	pcl(no) = partial cooling rate due to element 'no'
C
      character*2 names
      character*6 roman
      common /names/names(num),roman(30)
