/** \file TestFileImport.cxx
    \brief Implementation of FileImport unit test.
    \author James Peachey

    The Profit software package was developed by Dr. Randall Smith and
    Mr. James Peachey at the High Energy Astrophysics Science Archive
    Research Center (HEASARC) at the Goddard Space Flight Center (GSFC)
    of the National Aeronautics and Space Administration (NASA).
*/
#include "profit/FileImport.h"
#include "profit/Gui.h"
#include "profit/UnitTestGui.h"

namespace profit {

  void UnitTestGui::testFileImport() {
    std::string method = "testFileImport()";

    info(method) << "Creating file import dialog box for test." << std::endl;
    FileImport * import = new FileImport(Gui::instance());
    info(method) << std::endl;

    info(method) << "Running file import dialog box in test mode." << std::endl;
    import->runInTestMode();
    delete import;
    info(method) << std::endl;
  }

}
